/*
    Bantumi
    Copyright 2005 - 2007 Martin Storsjo

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Martin Storsjo
    martin@martin.st
*/

#include <SDL.h>
#include <SDL_opengl.h>

void makeScreenShot() {
	SDL_Surface *screen = SDL_GetVideoSurface();
#if SDL_BYTEORDER == SDL_LIL_ENDIAN
	SDL_Surface *surfc = SDL_CreateRGBSurface(SDL_SWSURFACE, screen->w, screen->h, 32, 0x000000FF, 0x0000FF00, 0x00FF0000, 0xFF000000);
	SDL_Surface *surfa = SDL_CreateRGBSurface(SDL_SWSURFACE, screen->w, screen->h, 32, 0x000000FF, 0x0000FF00, 0x00FF0000, 0xFF000000);
#else
	SDL_Surface *surfc = SDL_CreateRGBSurface(SDL_SWSURFACE, screen->w, screen->h, 32, 0xFF000000, 0x00FF0000, 0x0000FF00, 0x000000FF);
	SDL_Surface *surfa = SDL_CreateRGBSurface(SDL_SWSURFACE, screen->w, screen->h, 32, 0xFF000000, 0x00FF0000, 0x0000FF00, 0x000000FF);
#endif
	for (int y = 0; y < surfc->h; y++) {
		glReadPixels(0, surfc->h - 1 - y, surfc->w, 1, GL_RGBA, GL_UNSIGNED_BYTE, ((Uint8*)surfc->pixels) + y*surfc->pitch);
		for (int x = 0; x < surfc->w; x++) {
			Uint8 *c = (Uint8*)surfc->pixels + y*surfc->pitch + x*surfc->format->BytesPerPixel;
			Uint8 *a = (Uint8*)surfa->pixels + y*surfa->pitch + x*surfa->format->BytesPerPixel;
			a[0] = a[1] = a[2] = c[3];
			a[3] = c[3] = 255;
		}
	}
	SDL_SaveBMP(surfc, "sshot.bmp");
	SDL_SaveBMP(surfa, "sshot-alpha.bmp");
	SDL_FreeSurface(surfc);
	SDL_FreeSurface(surfa);
}

